package Sim;

/**
 * LocationManager provides a getLocation method to simulate moving nodes.
 *
 * @author Jason Winnebeck
 */
public interface LocationManager {
	/**
	 * Returns the location produced by this manager at the given time t. The value of t passed in
	 * must be equal to or greater than the value of all previous t values passed into this method.
	 *
	 * @return non-null generated Location
	 */
	public Location getLocation( double t );
}
