/*
 * AckWaiter.java
 *
 * Created on May 16, 2007, 12:06 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;

import Sim.SimulationEvent;
import Sim.Simulation;
import java.util.LinkedList;
import Sim.*;

/**
 *
 * @author Travis
 */
public class AckWaiter implements SimulationEvent{
    private int nextHop;
    private int sequenceNumber;
    
    private NormalPacketHeader normalHeader;
    private ChampAlgorithm champ;
    private RouteCache routeCache;
    private Packet packet;
    private Node myNode;
    private boolean acknowledged = false;
    
    /** Creates a new instance of AckWaiter */
    public AckWaiter( int sequenceNumber,
            int nextHop,NormalPacketHeader normalHeader,
            Packet dataPacket,
            RouteCache routeCache,
            ChampAlgorithm champ,
            Node myNode)  {
        
        this.nextHop = nextHop;
        this.sequenceNumber = sequenceNumber;
        this.routeCache = routeCache;
        this.packet= dataPacket;
        this.champ = champ;
        this.normalHeader = normalHeader;
        this.myNode =myNode;
    }
    
    
    /**
     *This event will check to see if an Ack has come in from
     *next hop node.  If it has not then it will perform Champ
     *route maintenance operations.
     *@sim
     *@time
     */
    public void perform(Simulation sim, double time){
        
        AckHeader toCheck = new AckHeader(sequenceNumber,nextHop);
        boolean found = false;
        
         if(myNode.getAddress() == 2){
            System.out.println("Ackwaiter");
         }
        
        if(acknowledged){
            if(myNode.getAddress()==2){
                System.out.print("found ack\n\n");
            }
           
            
        } else{
           
                System.out.println("didn't find ack");
            
            //if not found then remove from list of routes
            int lastdistance = routeCache.removeSuccessor(nextHop);  //should remove nextHop as successor
            
            
            //try another route if one exist
            System.out.println("Mynode"+ myNode.getAddress());
            NextHop next = routeCache.getNextHop(normalHeader.getDestination());
            if(next != null){
                HardwareFrame frame = new HardwareFrame(
                        champ.getAddress(),           //current node is source
                        next.getAddressAsInt(),       //previous should be destination
                        normalHeader,
                        packet);
                if(myNode.getAddress() == 11){
                    System.out.println("source "+normalHeader.getSourceAddress());
                    System.out.println("destination: "+normalHeader.getDestination());
                    System.out.println("Node 11 AckWaiter data.");
                }
                //          myNode.sendFrame(frame);
                //System.out.println("next.getAddress() "+ next.getAddressAsInt());
                //champ.forwardDataPacket(normalHeader,frame);  //forward packet
                
            } else if (next == null){   // we don't have next hop'
                champ.routeRepair(packet.getSource(),
                        packet.getDest(),
                        sequenceNumber,
                        0,
                        lastdistance,
                        packet);
            }
            
            
            
            //if no other then try to repair the route.
            
            //if all fail then broadcast RRER
            
        }
        
        
    }
    
    
    
    public boolean isAcknowledged(int nextHop,int sequenceNumber){
        if(this.nextHop == nextHop){
            if(this.sequenceNumber == sequenceNumber){
                this.acknowledged = true; 
            }
        }
        return acknowledged;
    }
    
}
