/*
 * NextHops.java
 *
 * Created on May 5, 2007, 10:30 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;

/**
 *
 * @author Travis Thomas
 */
public class NextHop {
    private double age = 0;
    int usedCount = 0;
    int address;
    boolean hasAddress = false;
    private int distance;
    

    
    
    /*
    Create a NextHop with an address
    */
    public NextHop(int address,int distance){
	    this.address = address;
            this.distance = distance;
    }
    
    
    
    /*getAddress() will return the address of this next hop
     *@return nethop
     */
    public int getAddress(){
        Integer nextHop = null;
            nextHop =  new Integer(address);


        return nextHop;
        
    }
    
    
    
    public int getAddressAsInt(){
        return address;
    }
    
    
    /*
     *public void setAddress will set the address of this successor node
     *@address will hold the address of this node.
     */
    public void setAddress(int address){
        this.address = address;
        hasAddress = true;
    }
    
    
    
    /*
     *getAge() will return the age of this route
     */
    public double getAge(){
        return age;
        
    }
    /*
     *use will update how old this route is.
     * The age of the route is calculated as the current time minus the last time
     * the route was used. Age is used in the RREP process for when an
     * intermediate node replys it will reply with the age of the 
     * freshest route.  Will return the address of this node  
     * @double currentTime
     * @return addressOfNode
     */
    public int use(double currentTime){
        age = currentTime - age;  //subtract age now from current time
        usedCount++;  //increment used count when used
        return address;
    }
    
    
    /*
     *getUsedCount will return how old this route is;
     *@return used
     */
    public int getUsedCount(){
        return usedCount;
    }

    public int getDistance() {
        return distance;
    }

    public void setAge(double age) {
        this.age = age;
    }
    
}
