/*
 * RREPHeader.java
 *
 * Created on May 8, 2007, 8:24 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;
import java.util.LinkedList;
import Sim.ProtocolFrame;

/**
 *
 * @author Travis
 */
public class RREPHeader implements ProtocolFrame{
    private int source;
    private int dest;
    private int seqNum;
    private LinkedList <Integer> previousHops;
    private int hopCount;
    private double age;
    private int routeLength;
    private int nodeReplyFrom;  //where this reply is coming from
    
    
    /** Creates a new instance of RREPHeader 
     *@param source
     @param dest
     @param seqNum
     @param prevHop
     @hopCount
     @age
     @routeLength*/
    public RREPHeader(
            int source,
            int dest,
            int seqNum,
            int nodeReplyFrom,
            LinkedList previousHops,
            int hopCount,
            double age,
            int routeLength) {
	            
        this.setSource(source);
        this.setDest(dest);
        this.setSeqNum(seqNum);
        this.setNodeReplyFrom(nodeReplyFrom);
        this.setPreviousHops(previousHops);
        this.setHopCount(hopCount);
        this.setAge(age);
        this.setRouteLength(routeLength);
    }
    
    
    /*
     *getSize will return the size in bytes of this header
     */
    public int getSize(){
        return 4 + 4 + 4 + 4 + 4 +  4 + 4 * previousHops.size();
    }

    public int getSource() {
        return source;
    }

    public void setSource(int source) {
        this.source = source;
    }

    public int getDest() {
        return dest;
    }

    public void setDest(int dest) {
        this.dest = dest;
    }

    public int getSeqNum() {
        return seqNum;
    }

    public void setSeqNum(int seqNum) {
        this.seqNum = seqNum;
    }

    public LinkedList<Integer> getPreviousHops() {
        return previousHops;
    }

    public void setPreviousHops(LinkedList<Integer> previousHops) {
        this.previousHops = previousHops;
    }

    public int getHopCount() {
        return hopCount;
    }

    public void setHopCount(int hopCount) {
        this.hopCount = hopCount;
    }



    public int getRouteLength() {
        return routeLength;
    }

    public void setRouteLength(int routeLength) {
        this.routeLength = routeLength;
    }

    public void setAge(double age) {
        this.age = age;
    }

    public double getAge() {
        return age;
    }

    public int getNodeReplyFrom() {
        return nodeReplyFrom;
    }

    public void setNodeReplyFrom(int nodeReplyFrom) {
        this.nodeReplyFrom = nodeReplyFrom;
    }
    
}
