/*
 * RREQTimeOutEvent.java
 *
 * Created on May 8, 2007, 6:02 AM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;

import Sim.SimulationEvent;
import Sim.Simulation;
import Sim.Node;
import Sim.HardwareFrame;
import Sim.Packet;

/**
 *
 * @author Travis
 */
public class RREQTimeOutEvent implements SimulationEvent {
    private HardwareFrame packetToSend;
    private HardwareFrame rreq;
    private boolean original; 
    private RouteRequested route;
    private final double ROUTE_REQUEST_TIME = 1;  //will be much slower here
    private Node myNode;
    private HardwareFrame error;
    private RouteCache routeCache;
    
    
    /** Creates a new instance of RREQTimeOutEvent */
    public RREQTimeOutEvent(HardwareFrame rreq,
            HardwareFrame frame,
            HardwareFrame error,
            boolean original,
            RouteRequested route,
            RouteCache routeCache,
            Node myNode) {
        
        
        this.original = original;
        this.rreq = rreq;
        this.packetToSend = frame;
        this.route = route;
        this.myNode = myNode;
        error = rreq;
        this.routeCache = routeCache;
        
        
            
    }
    
    
    /*
     *perform for this event will take care of RREQ timeouts
     *@param sim
     *@param time
     */
    public void perform(Simulation sim, double time){
        Packet packet = packetToSend.getUserData();
        NextHop nextHop = routeCache.getNextHop(packet.getDest());
        if(original){     //real source node need to do exponential backof            
            if(nextHop == null){  //if reply recieved do nothing
                //trying just give up.
           //     sim.scheduleEvent(sim.getTime() +  ROUTE_REQUEST_TIME,
           //             this);            
            }
            else{  //handeRREP should do this now
                //Packet packet = packetToSend.getUserData();
                //NextHop nextHop = routeCache.getNextHop(packet.getDest());
            
           /* NormalPacketHeader header = new NormalPacketHeader(route.getSequenceNumber(),
                    packet.getSource(),nextHop.getAddressAsInt(),packet.getDest());
            HardwareFrame frame = new HardwareFrame(packet.getSource(),
                        routeCache.getNextHop(packet.getDest()).getAddressAsInt(),
                        header,
                        packetToSend.getUserData());
                myNode.sendFrame(frame);*/  
            }
        }
        else{
            if(!route.isRequestStatus()){
                if(myNode.getAddress() == 11){
                System.out.println("Node 11 RREQTimeoute error?.");
            }
                myNode.sendFrame(error);
            }
        }
    }

   


    public boolean isOriginal() {
        return original;
    }

    public void setOriginal(boolean original) {
        this.original = original;
    }




}

   
        

    

