/*
 * RouteRepairTimeout.java
 *
 * Created on May 16, 2007, 3:07 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package Sim.Routing.Champ;

import Sim.SimulationEvent;
import Sim.Simulation;
import Sim.Packet;
import Sim.*;
import java.util.LinkedList;

/**
 *
 * @author Travis
 */
public class RouteRepairTimeout implements SimulationEvent {
    private Packet packet;
    private ChampAlgorithm champ;
    private NormalPacketHeader norHeader;
    private int sequenceNumber;
    private boolean replyReceived;
    private RouteCache routes;
   // private NextHop fromReply = null;  //will be set when replyReceived set to true.
    
    /** Creates a new instance of RouteRepairTimeout */
    public RouteRepairTimeout(int sequenceNumber, NormalPacketHeader norHeader,
            Packet packet, ChampAlgorithm champ) {
        this.packet = packet;
        this.champ = champ;
        this.norHeader = norHeader;
        this.sequenceNumber = sequenceNumber;
        routes = champ.getRouteCache();  //get copy of route cache
        
        
        
    }
    
    
    
    
    /**
     *Perform will figure out whether or not it now has a route for the packet.
     *If found a route send the packet.
     *If no route found the RERR will be generated.
     */
    public void perform(Simulation sim,double time ){
        RouteCache routes = champ.getRouteCache();
        if(replyReceived){              //if replyReceived it true
             NormalPacketHeader norHeader = new NormalPacketHeader(sequenceNumber,
                    packet.getSource(), 
                    champ.getAddress(),
                    packet.getDest());
            
            HardwareFrame justToPassPacketToForward = new HardwareFrame(
                    0,
                    0,
                    norHeader,
                    packet);   //really only needs packet in forward
            
            champ.forwardDataPacket(norHeader,justToPassPacketToForward);
        }
        else{     //if no reply then send error to previous hop

            champ.sendRERR(packet.getSource(),
                    packet.getDest(),
                    sequenceNumber,
                    norHeader.getPreviousHopAddress());  //send RERR to previous

            
        }
    }
    
}
