package Sim.Routing.DSR;

/**
 * PacketId uniquely identifies a packet in the simulation through originator address plus an
 * originator sequence ID.
 *
 * @author Jason Winnebeck
 */
public class PacketId {
	private final int originator;
	private final int id;

	public PacketId( int originator, int id ) {
		this.originator = originator;
		this.id = id;
	}

	/**
	 * Returns the originator's source address.
	 */
	public int getOriginator() {
		return originator;
	}

	public int getId() {
		return id;
	}

	@SuppressWarnings( { "MethodMayBeStatic" } )
	public int getSize() {
		return 4 + 4;
	}

	public boolean equals( Object o ) {
		if ( this == o ) return true;
		if ( o == null || getClass() != o.getClass() ) return false;

		PacketId packetId = (PacketId) o;

		if ( id != packetId.id ) return false;
		if ( originator != packetId.originator ) return false;

		return true;
	}

	public int hashCode() {
		int result;
		result = originator;
		result = 31 * result + id;
		return result;
	}

	public String toString() {
		return "[packet " + id + " from " + originator + "]";
	}
}
