package Sim.Routing.DSR;

import Sim.Packet;
import Sim.ProtocolFrame;
import org.gillius.Util.CheckUtils;

/**
 * PacketQueueItem is a QueueItem for a routable user packet with no additional protocol data.
*
* @author Jason Winnebeck
*/
class PacketQueueItem implements QueueItem {
	private final Packet packet;

	public PacketQueueItem( Packet packet ) {
		CheckUtils.checkNull( packet, "packet" );
		this.packet = packet;
	}

	public int getDest() {
		return packet.getDest();
	}

	public Packet getPacket() {
		return packet;
	}

	public ProtocolFrame getExtraData() {
		return null;
	}

	public String toString() {
		return "Queued " + packet;
	}
}
