package Sim.Routing.DSR;

import Sim.Packet;
import Sim.ProtocolFrame;

/**
 * QueueItem represents an expirable queue item that can be turned into a HardwareFrame with a
 * DataHeader.
*
* @author Jason Winnebeck
*/
interface QueueItem {
	/**
	 * Returns the node this item is meant to arrive at (eventually).
	 */
	public int getDest();

	/**
	 * Returns the user Packet, if there is one.
	 */
	public Packet getPacket();

	/**
	 * Returns a nested protocol frame for the DataHeader, if one is desired.
	 */
	public ProtocolFrame getExtraData();
}
